#include "matrix.h"
#include "kaestchen.h"
#include <iostream>//TODO

using namespace std;

Matrix::Matrix(): Matrix(0, 0) {}

Matrix::Matrix(int anzahlZeilen, int anzahlSpalten):
    anzahlZeilen {anzahlZeilen}, anzahlSpalten {anzahlSpalten}
{
    matrix.resize(anzahlZeilen*anzahlSpalten);
}

Matrix& Matrix::operator=(Matrix&& m)
{
    //lösche alte Werte
    for (Kaestchen* kaestchen: matrix)
        delete kaestchen;
    matrix.clear();

    matrix = std::move(m.matrix);
    anzahlZeilen = m.anzahlZeilen;
    anzahlSpalten = m.anzahlSpalten;
    m.anzahlZeilen = 0;
    m.anzahlSpalten = 0;
    return *this;
}

Kaestchen** Matrix::operator[](int zeile)
{
    return &matrix[zeile*anzahlSpalten];
}

Kaestchen** Matrix::begin()
{
    return &matrix[0];
}

Kaestchen** Matrix::end()
{
    return &matrix[anzahlZeilen*anzahlSpalten];
}
